use strict;
use warnings;
use Benchmark qw(:all);

sub twice_map {
    return map { $_ * 2 } @_;
}

sub twice_push {
    my @ret;
    push @ret, $_ * 2 for @_;
    return @ret;
}

my $count = 100000;
my @input = (1..10000);

cmpthese($count, {
    twice_map => sub {
        twice_map(@input);
    },
    twice_push => sub {
        twice_push(@input);
    },
});
